package com.contabilidad.EntConta;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "permisosempleados")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "Permisosempleados.findAll", query = "SELECT p FROM Permisosempleados p")
        , @NamedQuery(name = "Permisosempleados.findByIdpermisosempleados", query = "SELECT p FROM Permisosempleados p WHERE p.idpermisosempleados = :idpermisosempleados")
        , @NamedQuery(name = "Permisosempleados.findByObservaciones", query = "SELECT p FROM Permisosempleados p WHERE p.observaciones = :observaciones")
        , @NamedQuery(name = "Permisosempleados.findByFechapermiso", query = "SELECT p FROM Permisosempleados p WHERE p.fechapermiso = :fechapermiso")
        , @NamedQuery(name = "Permisosempleados.findByFecha", query = "SELECT p FROM Permisosempleados p WHERE p.fecha = :fecha")
        , @NamedQuery(name = "Permisosempleados.findByDuracion", query = "SELECT p FROM Permisosempleados p WHERE p.duracion = :duracion")
        , @NamedQuery(name = "Permisosempleados.findByOtorgadopor", query = "SELECT p FROM Permisosempleados p WHERE p.otorgadopor = :otorgadopor")
        , @NamedQuery(name = "Permisosempleados.findByHorasalida", query = "SELECT p FROM Permisosempleados p WHERE p.horasalida = :horasalida")
        , @NamedQuery(name = "Permisosempleados.findByHoraregreso", query = "SELECT p FROM Permisosempleados p WHERE p.horaregreso = :horaregreso")
        , @NamedQuery(name = "Permisosempleados.findByTipo", query = "SELECT p FROM Permisosempleados p WHERE p.tipo = :tipo")
        //, @NamedQuery(name = "Permisosempleados.findByUsuarioCodigo", query = "SELECT p FROM Permisosempleados p WHERE p.usuarioCodigo = :usuarioCodigo")
        , @NamedQuery(name = "Permisosempleados.findByCodigoEmpleado", query = "SELECT p FROM Permisosempleados p WHERE p.codigoEmpleado = :codigoEmpleado")})
public class Permisosempleados implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @NotNull
    @Size(min = 1, max = 5)
    @Column(name = "idpermisosempleados")
    private Integer idpermisosempleados;
    @Size(max = 200)
    @Column(name = "observaciones")
    private String observaciones;
    @Column(name = "fechapermiso")
    @Temporal(TemporalType.DATE)
    private Date fechapermiso;
    @Column(name = "fecha")
    @Temporal(TemporalType.DATE)
    private Date fecha;
    @Size(max = 30)
    @Column(name = "duracion")
    private String duracion;
    @Size(max = 30)
    @Column(name = "otorgadopor")
    private String otorgadopor;
    @Column(name = "horasalida")
    @Temporal(TemporalType.TIMESTAMP)
    private Date horasalida;
    @Column(name = "horaregreso")
    @Temporal(TemporalType.TIMESTAMP)
    private Date horaregreso;
    @Size(max = 15)
    @Column(name = "tipo")
    private String tipo;
    @Size(max = 3)
    @Column(name = "usuario_codigo")
    private String usuarioCodigo;
    @Size(max = 3)
    @Column(name = "codigo_empleado")
    private String codigoEmpleado;

   /* @OneToMany(cascade = CascadeType.ALL, mappedBy = "usuario")
    private List<usuario> UsuariosList;*/

    public Permisosempleados() {
    }

    public Permisosempleados(Integer idpermisosempleados) {
        this.idpermisosempleados = idpermisosempleados;
    }

    public Integer getIdpermisosempleados() {
        return idpermisosempleados;
    }

    public void setIdpermisosempleados(Integer idpermisosempleados) {
        this.idpermisosempleados = idpermisosempleados;
    }

    public String getObservaciones() {
        return observaciones;
    }

    public void setObservaciones(String observaciones) {
        this.observaciones = observaciones;
    }

    public Date getFechapermiso() {
        return fechapermiso;
    }

    public void setFechapermiso(Date fechapermiso) {
        this.fechapermiso = fechapermiso;
    }

    public Date getFecha() {
        return fecha;
    }

    public void setFecha(Date fecha) {
        this.fecha = fecha;
    }

    public String getDuracion() {
        return duracion;
    }

    public void setDuracion(String duracion) {
        this.duracion = duracion;
    }

    public String getOtorgadopor() {
        return otorgadopor;
    }

    public void setOtorgadopor(String otorgadopor) {
        this.otorgadopor = otorgadopor;
    }

    public Date getHorasalida() {
        return horasalida;
    }

    public void setHorasalida(Date horasalida) {
        this.horasalida = horasalida;
    }

    public Date getHoraregreso() {
        return horaregreso;
    }

    public void setHoraregreso(Date horaregreso) {
        this.horaregreso = horaregreso;
    }

    public String getTipo() {
        return tipo;
    }

    public void setTipo(String tipo) {
        this.tipo = tipo;
    }

    public String getUsuarioCodigo() {
        return usuarioCodigo;
    }

    public void setUsuarioCodigo(String usuarioCodigo) {
        this.usuarioCodigo = usuarioCodigo;
    }

    public String getCodigoEmpleado() {
        return codigoEmpleado;
    }

    public void setCodigoEmpleado(String codigoEmpleado) {
        this.codigoEmpleado = codigoEmpleado;
    }

    /*public List<usuario> getUsuariosList() { return UsuariosList; }

    public void setUsuariosList(List<usuario> usuariosList) { UsuariosList = usuariosList; }*/

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idpermisosempleados != null ? idpermisosempleados.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Permisosempleados)) {
            return false;
        }
        Permisosempleados other = (Permisosempleados) object;
        if ((this.idpermisosempleados == null && other.idpermisosempleados != null) || (this.idpermisosempleados != null && !this.idpermisosempleados.equals(other.idpermisosempleados))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.contabilidad.dbcom.Permisosempleados[ idpermisosempleados=" + idpermisosempleados + " ]";
    }

}
